<!DOCTYPE html>

<html>

<head>

<meta charset="utf-8" />
<meta name="generator" content="pandoc" />
<meta http-equiv="X-UA-Compatible" content="IE=EDGE" />

<meta name="viewport" content="width=device-width, initial-scale=1" />

<meta name="author" content="James E. Pustejovsky" />

<meta name="date" content="2022-08-13" />

<title>Cluster-robust standard errors and hypothesis tests in panel data models</title>

<script>// Pandoc 2.9 adds attributes on both header and div. We remove the former (to
// be compatible with the behavior of Pandoc < 2.8).
document.addEventListener('DOMContentLoaded', function(e) {
  var hs = document.querySelectorAll("div.section[class*='level'] > :first-child");
  var i, h, a;
  for (i = 0; i < hs.length; i++) {
    h = hs[i];
    if (!/^h[1-6]$/i.test(h.tagName)) continue;  // it should be a header h1-h6
    a = h.attributes;
    while (a.length > 0) h.removeAttribute(a[0].name);
  }
});
</script>

<style type="text/css">
  code{white-space: pre-wrap;}
  span.smallcaps{font-variant: small-caps;}
  span.underline{text-decoration: underline;}
  div.column{display: inline-block; vertical-align: top; width: 50%;}
  div.hanging-indent{margin-left: 1.5em; text-indent: -1.5em;}
  ul.task-list{list-style: none;}
    </style>


<style type="text/css">
  code {
    white-space: pre;
  }
  .sourceCode {
    overflow: visible;
  }
</style>
<style type="text/css" data-origin="pandoc">
pre > code.sourceCode { white-space: pre; position: relative; }
pre > code.sourceCode > span { display: inline-block; line-height: 1.25; }
pre > code.sourceCode > span:empty { height: 1.2em; }
.sourceCode { overflow: visible; }
code.sourceCode > span { color: inherit; text-decoration: inherit; }
div.sourceCode { margin: 1em 0; }
pre.sourceCode { margin: 0; }
@media screen {
div.sourceCode { overflow: auto; }
}
@media print {
pre > code.sourceCode { white-space: pre-wrap; }
pre > code.sourceCode > span { text-indent: -5em; padding-left: 5em; }
}
pre.numberSource code
  { counter-reset: source-line 0; }
pre.numberSource code > span
  { position: relative; left: -4em; counter-increment: source-line; }
pre.numberSource code > span > a:first-child::before
  { content: counter(source-line);
    position: relative; left: -1em; text-align: right; vertical-align: baseline;
    border: none; display: inline-block;
    -webkit-touch-callout: none; -webkit-user-select: none;
    -khtml-user-select: none; -moz-user-select: none;
    -ms-user-select: none; user-select: none;
    padding: 0 4px; width: 4em;
    color: #aaaaaa;
  }
pre.numberSource { margin-left: 3em; border-left: 1px solid #aaaaaa;  padding-left: 4px; }
div.sourceCode
  {   }
@media screen {
pre > code.sourceCode > span > a:first-child::before { text-decoration: underline; }
}
code span.al { color: #ff0000; font-weight: bold; } /* Alert */
code span.an { color: #60a0b0; font-weight: bold; font-style: italic; } /* Annotation */
code span.at { color: #7d9029; } /* Attribute */
code span.bn { color: #40a070; } /* BaseN */
code span.bu { } /* BuiltIn */
code span.cf { color: #007020; font-weight: bold; } /* ControlFlow */
code span.ch { color: #4070a0; } /* Char */
code span.cn { color: #880000; } /* Constant */
code span.co { color: #60a0b0; font-style: italic; } /* Comment */
code span.cv { color: #60a0b0; font-weight: bold; font-style: italic; } /* CommentVar */
code span.do { color: #ba2121; font-style: italic; } /* Documentation */
code span.dt { color: #902000; } /* DataType */
code span.dv { color: #40a070; } /* DecVal */
code span.er { color: #ff0000; font-weight: bold; } /* Error */
code span.ex { } /* Extension */
code span.fl { color: #40a070; } /* Float */
code span.fu { color: #06287e; } /* Function */
code span.im { } /* Import */
code span.in { color: #60a0b0; font-weight: bold; font-style: italic; } /* Information */
code span.kw { color: #007020; font-weight: bold; } /* Keyword */
code span.op { color: #666666; } /* Operator */
code span.ot { color: #007020; } /* Other */
code span.pp { color: #bc7a00; } /* Preprocessor */
code span.sc { color: #4070a0; } /* SpecialChar */
code span.ss { color: #bb6688; } /* SpecialString */
code span.st { color: #4070a0; } /* String */
code span.va { color: #19177c; } /* Variable */
code span.vs { color: #4070a0; } /* VerbatimString */
code span.wa { color: #60a0b0; font-weight: bold; font-style: italic; } /* Warning */

</style>
<script>
// apply pandoc div.sourceCode style to pre.sourceCode instead
(function() {
  var sheets = document.styleSheets;
  for (var i = 0; i < sheets.length; i++) {
    if (sheets[i].ownerNode.dataset["origin"] !== "pandoc") continue;
    try { var rules = sheets[i].cssRules; } catch (e) { continue; }
    for (var j = 0; j < rules.length; j++) {
      var rule = rules[j];
      // check if there is a div.sourceCode rule
      if (rule.type !== rule.STYLE_RULE || rule.selectorText !== "div.sourceCode") continue;
      var style = rule.style.cssText;
      // check if color or background-color is set
      if (rule.style.color === '' && rule.style.backgroundColor === '') continue;
      // replace div.sourceCode by a pre.sourceCode rule
      sheets[i].deleteRule(j);
      sheets[i].insertRule('pre.sourceCode{' + style + '}', j);
    }
  }
})();
</script>




<style type="text/css">body {
background-color: #fff;
margin: 1em auto;
max-width: 700px;
overflow: visible;
padding-left: 2em;
padding-right: 2em;
font-family: "Open Sans", "Helvetica Neue", Helvetica, Arial, sans-serif;
font-size: 14px;
line-height: 1.35;
}
#TOC {
clear: both;
margin: 0 0 10px 10px;
padding: 4px;
width: 400px;
border: 1px solid #CCCCCC;
border-radius: 5px;
background-color: #f6f6f6;
font-size: 13px;
line-height: 1.3;
}
#TOC .toctitle {
font-weight: bold;
font-size: 15px;
margin-left: 5px;
}
#TOC ul {
padding-left: 40px;
margin-left: -1.5em;
margin-top: 5px;
margin-bottom: 5px;
}
#TOC ul ul {
margin-left: -2em;
}
#TOC li {
line-height: 16px;
}
table {
margin: 1em auto;
border-width: 1px;
border-color: #DDDDDD;
border-style: outset;
border-collapse: collapse;
}
table th {
border-width: 2px;
padding: 5px;
border-style: inset;
}
table td {
border-width: 1px;
border-style: inset;
line-height: 18px;
padding: 5px 5px;
}
table, table th, table td {
border-left-style: none;
border-right-style: none;
}
table thead, table tr.even {
background-color: #f7f7f7;
}
p {
margin: 0.5em 0;
}
blockquote {
background-color: #f6f6f6;
padding: 0.25em 0.75em;
}
hr {
border-style: solid;
border: none;
border-top: 1px solid #777;
margin: 28px 0;
}
dl {
margin-left: 0;
}
dl dd {
margin-bottom: 13px;
margin-left: 13px;
}
dl dt {
font-weight: bold;
}
ul {
margin-top: 0;
}
ul li {
list-style: circle outside;
}
ul ul {
margin-bottom: 0;
}
pre, code {
background-color: #f7f7f7;
border-radius: 3px;
color: #333;
white-space: pre-wrap; 
}
pre {
border-radius: 3px;
margin: 5px 0px 10px 0px;
padding: 10px;
}
pre:not([class]) {
background-color: #f7f7f7;
}
code {
font-family: Consolas, Monaco, 'Courier New', monospace;
font-size: 85%;
}
p > code, li > code {
padding: 2px 0px;
}
div.figure {
text-align: center;
}
img {
background-color: #FFFFFF;
padding: 2px;
border: 1px solid #DDDDDD;
border-radius: 3px;
border: 1px solid #CCCCCC;
margin: 0 5px;
}
h1 {
margin-top: 0;
font-size: 35px;
line-height: 40px;
}
h2 {
border-bottom: 4px solid #f7f7f7;
padding-top: 10px;
padding-bottom: 2px;
font-size: 145%;
}
h3 {
border-bottom: 2px solid #f7f7f7;
padding-top: 10px;
font-size: 120%;
}
h4 {
border-bottom: 1px solid #f7f7f7;
margin-left: 8px;
font-size: 105%;
}
h5, h6 {
border-bottom: 1px solid #ccc;
font-size: 105%;
}
a {
color: #0033dd;
text-decoration: none;
}
a:hover {
color: #6666ff; }
a:visited {
color: #800080; }
a:visited:hover {
color: #BB00BB; }
a[href^="http:"] {
text-decoration: underline; }
a[href^="https:"] {
text-decoration: underline; }

code > span.kw { color: #555; font-weight: bold; } 
code > span.dt { color: #902000; } 
code > span.dv { color: #40a070; } 
code > span.bn { color: #d14; } 
code > span.fl { color: #d14; } 
code > span.ch { color: #d14; } 
code > span.st { color: #d14; } 
code > span.co { color: #888888; font-style: italic; } 
code > span.ot { color: #007020; } 
code > span.al { color: #ff0000; font-weight: bold; } 
code > span.fu { color: #900; font-weight: bold; } 
code > span.er { color: #a61717; background-color: #e3d2d2; } 
</style>




</head>

<body>




<h1 class="title toc-ignore">Cluster-robust standard errors and
hypothesis tests in panel data models</h1>
<h4 class="author">James E. Pustejovsky</h4>
<h4 class="date">2022-08-13</h4>



<p>The importance of using cluster-robust variance estimators (i.e.,
“clustered standard errors”) in panel models is now widely recognized.
Less widely recognized is the fact that standard methods for
constructing hypothesis tests and confidence intervals based on CRVE can
perform quite poorly in when based on a limited number of independent
clusters. Furthermore, it can be difficult to determine what counts as a
large-enough sample to trust standard CRVE methods, because the
finite-sample behavior of the variance estimators and test statistics
depends on the configuration of the covariates, not just the total
number of clusters.</p>
<p>One solution to this problem is to use bias-reduced linearization
(BRL), which was proposed by Bell and McCaffrey (2002) and has recently
begun to receive attention in the econometrics literature (e.g., Cameron
&amp; Miller, 2015; Imbens &amp; Kolesar, 2015). The idea of BRL is to
correct the bias of standard CRVE based on a working model, and then to
use a degrees-of-freedom correction for Wald tests based on the
bias-reduced CRVE. That may seem silly (after all, the whole point of
CRVE is to avoid making distributional assumptions about the errors in
your model), but it turns out that the correction can help quite a bit,
even when the working model is wrong. The degrees-of-freedom correction
is based on a standard Satterthwaite-type approximation, and also relies
on the working model.</p>
<p>A problem with Bell and McCaffrey’s original formulation of BRL is
that it does not work in some very common models for panel data, such as
state-by-year panels that include fixed effects for each state and each
year (Angrist and Pischke, 2009, point out this issue in their chapter
on “non-standard standard error issues”; see also Young, 2016). However,
Pustejovsky and Tipton (2016) proposed a generalization of BRL that
works even in models with arbitrary sets of fixed effects, and this
generalization is implemented in <code>clubSandwich</code> as CRVE type
<code>CR2</code>. The package also implements small-sample corrections
for multiple-constraint hypothesis tests based on an approximation
proposed by Pustejovsky and Tipton (2016). For one-parameter
constraints, the test reduces to a t-test with Satterthwaite degrees of
freedom, and so it is a natural extension of BRL.</p>
<p>The following example demonstrates how to use
<code>clubSandwich</code> to do cluster-robust inference for a
state-by-year panel model with fixed effects in both dimensions,
clustering by states.</p>
<div id="effects-of-changing-the-minimum-legal-drinking-age" class="section level2">
<h2>Effects of changing the minimum legal drinking age</h2>
<p>Carpenter and Dobkin (2011) analyzed the effects of changes in the
minimum legal drinking age on rates of motor vehicle fatalities among
18-20 year olds, using state-level panel data from the National Highway
Traffic Administration’s Fatal Accident Reporting System. In their new
textbook, Angrist and Pischke (2014) developed a stylized example based
on Carpenter and Dobkin’s work. The following example uses Angrist and
Pischke’s data and follows their analysis because their data are <a href="https://www.masteringmetrics.com/resources/">easily
available</a>.</p>
<p>The outcome is the incidence of deaths in motor vehicle crashes among
18-20 year-olds (per 100,000 residents), for each state plus the
District of Columbia, over the period 1970 to 1983. There were several
changes in the minimum legal drinking age during this time period, with
variability in the timing of changes across states. Angrist and Pischke
(following Carpenter and Dobkin) use a difference-in-differences
strategy to estimate the effects of lowering the minimum legal drinking
age from 21 to 18. Their specification is</p>
<p><span class="math display">\[y_{it} = \alpha_i + \beta_t + \gamma
b_{it} + \delta d_{it} + \epsilon_{it},\]</span></p>
<p>for <span class="math inline">\(i\)</span> = 1,…,51 and <span class="math inline">\(t\)</span> = 1970,…,1983. In this model, <span class="math inline">\(\alpha_i\)</span> is a state-specific fixed
effect, <span class="math inline">\(\beta_t\)</span> is a year-specific
fixed effect, <span class="math inline">\(b_{it}\)</span> is the current
rate of beer taxation in state <span class="math inline">\(i\)</span> in
year <span class="math inline">\(t\)</span>, <span class="math inline">\(d_{it}\)</span> is the proportion of 18-20
year-olds in state <span class="math inline">\(i\)</span> in year <span class="math inline">\(t\)</span> who are legally allowed to drink, and
<span class="math inline">\(\delta\)</span> captures the effect of
shifting the minimum legal drinking age from 21 to 18. Following Angrist
and Pischke’s analysis, we estimate this model both by (unweighted) OLS
and by weighted least squares with weights corresponding to population
size in a given state and year. We also demonstrate random effects
estimation and implement a cluster-robust Hausman specification
test.</p>
</div>
<div id="unweighted-ols" class="section level2">
<h2>Unweighted OLS</h2>
<p>The following code does some simple data-munging and the estimates
the model by OLS:</p>
<div class="sourceCode" id="cb1"><pre class="sourceCode r"><code class="sourceCode r"><span id="cb1-1"><a href="#cb1-1" aria-hidden="true" tabindex="-1"></a><span class="fu">library</span>(clubSandwich)</span>
<span id="cb1-2"><a href="#cb1-2" aria-hidden="true" tabindex="-1"></a><span class="fu">data</span>(MortalityRates)</span>
<span id="cb1-3"><a href="#cb1-3" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb1-4"><a href="#cb1-4" aria-hidden="true" tabindex="-1"></a><span class="co"># subset for deaths in motor vehicle accidents, 1970-1983</span></span>
<span id="cb1-5"><a href="#cb1-5" aria-hidden="true" tabindex="-1"></a>MV_deaths <span class="ot">&lt;-</span> <span class="fu">subset</span>(MortalityRates, cause<span class="sc">==</span><span class="st">&quot;Motor Vehicle&quot;</span> <span class="sc">&amp;</span> </span>
<span id="cb1-6"><a href="#cb1-6" aria-hidden="true" tabindex="-1"></a>                      year <span class="sc">&lt;=</span> <span class="dv">1983</span> <span class="sc">&amp;</span> <span class="sc">!</span><span class="fu">is.na</span>(beertaxa))</span>
<span id="cb1-7"><a href="#cb1-7" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb1-8"><a href="#cb1-8" aria-hidden="true" tabindex="-1"></a><span class="co"># fit by OLS</span></span>
<span id="cb1-9"><a href="#cb1-9" aria-hidden="true" tabindex="-1"></a>lm_unweighted <span class="ot">&lt;-</span> <span class="fu">lm</span>(mrate <span class="sc">~</span> <span class="dv">0</span> <span class="sc">+</span> legal <span class="sc">+</span> beertaxa <span class="sc">+</span> </span>
<span id="cb1-10"><a href="#cb1-10" aria-hidden="true" tabindex="-1"></a>                      <span class="fu">factor</span>(state) <span class="sc">+</span> <span class="fu">factor</span>(year), <span class="at">data =</span> MV_deaths)</span></code></pre></div>
<p>The <code>coef_test</code> function from <code>clubSandwich</code>
can then be used to test the hypothesis that changing the minimum legal
drinking age has no effect on motor vehicle deaths in this cohort (i.e.,
<span class="math inline">\(H_0: \delta = 0\)</span>). The usual way to
test this is to cluster the standard errors by state, calculate the
robust Wald statistic, and compare that to a standard normal reference
distribution. The code and results are as follows:</p>
<div class="sourceCode" id="cb2"><pre class="sourceCode r"><code class="sourceCode r"><span id="cb2-1"><a href="#cb2-1" aria-hidden="true" tabindex="-1"></a><span class="fu">coef_test</span>(lm_unweighted, <span class="at">vcov =</span> <span class="st">&quot;CR1&quot;</span>, </span>
<span id="cb2-2"><a href="#cb2-2" aria-hidden="true" tabindex="-1"></a>          <span class="at">cluster =</span> MV_deaths<span class="sc">$</span>state, <span class="at">test =</span> <span class="st">&quot;naive-t&quot;</span>)[<span class="dv">1</span><span class="sc">:</span><span class="dv">2</span>,]</span></code></pre></div>
<pre><code>##     Coef. Estimate   SE t-stat d.f. (naive-t) p-val (naive-t) Sig.
##     legal     7.59 2.44  3.108             49         0.00313   **
##  beertaxa     3.82 5.14  0.743             49         0.46128</code></pre>
<p>A better approach would be to use the generalized, bias-reduced
linearization CRVE, together with Satterthwaite degrees of freedom. In
the <code>clubSandwich</code> package, the BRL adjustment is called
“CR2” because it is directly analogous to the HC2 correction used in
heteroskedasticity-robust variance estimation. When applied to an OLS
model estimated by <code>lm</code>, the default working model is an
identity matrix, which amounts to the “working” assumption that the
errors are all uncorrelated and homoskedastic. Here’s how to apply this
approach in the example:</p>
<div class="sourceCode" id="cb4"><pre class="sourceCode r"><code class="sourceCode r"><span id="cb4-1"><a href="#cb4-1" aria-hidden="true" tabindex="-1"></a><span class="fu">coef_test</span>(lm_unweighted, <span class="at">vcov =</span> <span class="st">&quot;CR2&quot;</span>, </span>
<span id="cb4-2"><a href="#cb4-2" aria-hidden="true" tabindex="-1"></a>          <span class="at">cluster =</span> MV_deaths<span class="sc">$</span>state, <span class="at">test =</span> <span class="st">&quot;Satterthwaite&quot;</span>)[<span class="dv">1</span><span class="sc">:</span><span class="dv">2</span>,]</span></code></pre></div>
<pre><code>##     Coef. Estimate   SE t-stat d.f. (Satt) p-val (Satt) Sig.
##     legal     7.59 2.51  3.019       24.58      0.00583   **
##  beertaxa     3.82 5.27  0.725        5.77      0.49663</code></pre>
<p>The Satterthwaite degrees of freedom are different for each
coefficient in the model, and so the <code>coef_test</code> function
reports them right alongside the standard error. For the effect of legal
drinking age, the degrees of freedom are about half of what might be
expected, given that there are 51 clusters. The p-value for the
CR2+Satterthwaite test is about twice as large as the p-value based on
the standard Wald test, although the coefficient is still statistically
significant at conventional levels. Note, however, that the degrees of
freedom on the beer taxation rate are considerably smaller because there
are only a few states with substantial variability in taxation rates
over time.</p>
</div>
<div id="unweighted-within-estimation" class="section level2">
<h2>Unweighted “within” estimation</h2>
<p>The <code>plm</code> package in R provides another way to estimate
the same model. It is convenient because it absorbs the state and year
fixed effects before estimating the effect of <code>legal</code>. The
<code>clubSandwich</code> package works with fitted <code>plm</code>
models too:</p>
<div class="sourceCode" id="cb6"><pre class="sourceCode r"><code class="sourceCode r"><span id="cb6-1"><a href="#cb6-1" aria-hidden="true" tabindex="-1"></a><span class="fu">library</span>(plm)</span>
<span id="cb6-2"><a href="#cb6-2" aria-hidden="true" tabindex="-1"></a>plm_unweighted <span class="ot">&lt;-</span> <span class="fu">plm</span>(mrate <span class="sc">~</span> legal <span class="sc">+</span> beertaxa, <span class="at">data =</span> MV_deaths, </span>
<span id="cb6-3"><a href="#cb6-3" aria-hidden="true" tabindex="-1"></a>                      <span class="at">effect =</span> <span class="st">&quot;twoways&quot;</span>, <span class="at">index =</span> <span class="fu">c</span>(<span class="st">&quot;state&quot;</span>,<span class="st">&quot;year&quot;</span>))</span>
<span id="cb6-4"><a href="#cb6-4" aria-hidden="true" tabindex="-1"></a><span class="fu">coef_test</span>(plm_unweighted, <span class="at">vcov =</span> <span class="st">&quot;CR1&quot;</span>, <span class="at">cluster =</span> <span class="st">&quot;individual&quot;</span>, <span class="at">test =</span> <span class="st">&quot;naive-t&quot;</span>)</span></code></pre></div>
<pre><code>##     Coef. Estimate   SE t-stat d.f. (naive-t) p-val (naive-t) Sig.
##     legal     7.59 2.44  3.108             49         0.00313   **
##  beertaxa     3.82 5.14  0.743             49         0.46128</code></pre>
<div class="sourceCode" id="cb8"><pre class="sourceCode r"><code class="sourceCode r"><span id="cb8-1"><a href="#cb8-1" aria-hidden="true" tabindex="-1"></a><span class="fu">coef_test</span>(plm_unweighted, <span class="at">vcov =</span> <span class="st">&quot;CR2&quot;</span>, <span class="at">cluster =</span> <span class="st">&quot;individual&quot;</span>, <span class="at">test =</span> <span class="st">&quot;Satterthwaite&quot;</span>)</span></code></pre></div>
<pre><code>##     Coef. Estimate   SE t-stat d.f. (Satt) p-val (Satt) Sig.
##     legal     7.59 2.51  3.019       24.58      0.00583   **
##  beertaxa     3.82 5.27  0.725        5.77      0.49663</code></pre>
</div>
<div id="population-weighted-estimation" class="section level2">
<h2>Population-weighted estimation</h2>
<p>The difference between the standard method and the new method are not
terribly exciting in the above example. However, things change quite a
bit if the model is estimated using population weights. We go back to
fitting in <code>lm</code> with dummies for all the fixed effects
because <code>plm</code> does not handle weighted least squares.</p>
<div class="sourceCode" id="cb10"><pre class="sourceCode r"><code class="sourceCode r"><span id="cb10-1"><a href="#cb10-1" aria-hidden="true" tabindex="-1"></a>lm_weighted <span class="ot">&lt;-</span> <span class="fu">lm</span>(mrate <span class="sc">~</span> <span class="dv">0</span> <span class="sc">+</span> legal <span class="sc">+</span> beertaxa <span class="sc">+</span> <span class="fu">factor</span>(state) <span class="sc">+</span> <span class="fu">factor</span>(year), </span>
<span id="cb10-2"><a href="#cb10-2" aria-hidden="true" tabindex="-1"></a>                  <span class="at">weights =</span> pop, <span class="at">data =</span> MV_deaths)</span>
<span id="cb10-3"><a href="#cb10-3" aria-hidden="true" tabindex="-1"></a><span class="fu">coef_test</span>(lm_weighted, <span class="at">vcov =</span> <span class="st">&quot;CR1&quot;</span>, </span>
<span id="cb10-4"><a href="#cb10-4" aria-hidden="true" tabindex="-1"></a>          <span class="at">cluster =</span> MV_deaths<span class="sc">$</span>state, <span class="at">test =</span> <span class="st">&quot;naive-t&quot;</span>)[<span class="dv">1</span><span class="sc">:</span><span class="dv">2</span>,]</span></code></pre></div>
<pre><code>##     Coef. Estimate   SE t-stat d.f. (naive-t) p-val (naive-t) Sig.
##     legal     7.78 2.01   3.87             49          &lt;0.001  ***
##  beertaxa    11.16 4.20   2.66             49          0.0106    *</code></pre>
<div class="sourceCode" id="cb12"><pre class="sourceCode r"><code class="sourceCode r"><span id="cb12-1"><a href="#cb12-1" aria-hidden="true" tabindex="-1"></a><span class="fu">coef_test</span>(lm_weighted, <span class="at">vcov =</span> <span class="st">&quot;CR2&quot;</span>, </span>
<span id="cb12-2"><a href="#cb12-2" aria-hidden="true" tabindex="-1"></a>          <span class="at">cluster =</span> MV_deaths<span class="sc">$</span>state, <span class="at">test =</span> <span class="st">&quot;Satterthwaite&quot;</span>)[<span class="dv">1</span><span class="sc">:</span><span class="dv">2</span>,]</span></code></pre></div>
<pre><code>##     Coef. Estimate   SE t-stat d.f. (Satt) p-val (Satt) Sig.
##     legal     7.78 2.13   3.64        8.52      0.00588   **
##  beertaxa    11.16 4.37   2.55        6.85      0.03854    *</code></pre>
<p>Using population weights slightly reduces the point estimate of the
effect, while also slightly increasing its precision. If you were
following the standard approach, you would probably be happy with the
weighted estimates and wouldn’t think about it any further. However,
using the CR2 variance estimator and Satterthwaite correction produces a
p-value that is an order of magnitude larger (though still significant
at the conventional 5% level). The degrees of freedom are just
8.5—drastically smaller than would be expected based on the number of
clusters.</p>
<p>Even with weights, the <code>coef_test</code> function uses an
“independent, homoskedastic” working model as a default for
<code>lm</code> objects. In the present example, the outcome is a
standardized rate and so a better assumption might be that the error
variances are inversely proportional to population size. The following
code uses this alternate working model:</p>
<div class="sourceCode" id="cb14"><pre class="sourceCode r"><code class="sourceCode r"><span id="cb14-1"><a href="#cb14-1" aria-hidden="true" tabindex="-1"></a><span class="fu">coef_test</span>(lm_weighted, <span class="at">vcov =</span> <span class="st">&quot;CR2&quot;</span>, </span>
<span id="cb14-2"><a href="#cb14-2" aria-hidden="true" tabindex="-1"></a>          <span class="at">cluster =</span> MV_deaths<span class="sc">$</span>state, <span class="at">target =</span> <span class="dv">1</span> <span class="sc">/</span> MV_deaths<span class="sc">$</span>pop, </span>
<span id="cb14-3"><a href="#cb14-3" aria-hidden="true" tabindex="-1"></a>          <span class="at">test =</span> <span class="st">&quot;Satterthwaite&quot;</span>)[<span class="dv">1</span><span class="sc">:</span><span class="dv">2</span>,]</span></code></pre></div>
<pre><code>##     Coef. Estimate   SE t-stat d.f. (Satt) p-val (Satt) Sig.
##     legal     7.78 2.03   3.83       12.64      0.00221   **
##  beertaxa    11.16 4.17   2.68        5.06      0.04333    *</code></pre>
<p>The new working model leads to slightly smaller standard errors and a
couple of additional degrees of freedom, though they remain in
small-sample territory.</p>
</div>
<div id="random-effects-estimation" class="section level2">
<h2>Random effects estimation</h2>
<p>If the unobserved effects <span class="math inline">\(\alpha_1,...,\alpha_{51}\)</span> are uncorrelated
with the regressors, then a more efficient way to estimate <span class="math inline">\(\gamma,\delta\)</span> is by weighted least
squares, with weights based on a random effects model. We still treat
the year effects as fixed.</p>
<div class="sourceCode" id="cb16"><pre class="sourceCode r"><code class="sourceCode r"><span id="cb16-1"><a href="#cb16-1" aria-hidden="true" tabindex="-1"></a>plm_random <span class="ot">&lt;-</span> <span class="fu">plm</span>(mrate <span class="sc">~</span> <span class="dv">0</span> <span class="sc">+</span> legal <span class="sc">+</span> beertaxa <span class="sc">+</span> year, <span class="at">data =</span> MV_deaths, </span>
<span id="cb16-2"><a href="#cb16-2" aria-hidden="true" tabindex="-1"></a>                  <span class="at">effect =</span> <span class="st">&quot;individual&quot;</span>, <span class="at">index =</span> <span class="fu">c</span>(<span class="st">&quot;state&quot;</span>,<span class="st">&quot;year&quot;</span>),</span>
<span id="cb16-3"><a href="#cb16-3" aria-hidden="true" tabindex="-1"></a>                  <span class="at">model =</span> <span class="st">&quot;random&quot;</span>)</span>
<span id="cb16-4"><a href="#cb16-4" aria-hidden="true" tabindex="-1"></a><span class="fu">coef_test</span>(plm_random, <span class="at">vcov =</span> <span class="st">&quot;CR1&quot;</span>, <span class="at">test =</span> <span class="st">&quot;naive-t&quot;</span>)[<span class="dv">1</span><span class="sc">:</span><span class="dv">2</span>,]</span></code></pre></div>
<pre><code>##     Coef. Estimate   SE t-stat d.f. (naive-t) p-val (naive-t) Sig.
##     legal     7.31 2.39  3.054             49         0.00364   **
##  beertaxa     3.37 5.11  0.661             49         0.51202</code></pre>
<div class="sourceCode" id="cb18"><pre class="sourceCode r"><code class="sourceCode r"><span id="cb18-1"><a href="#cb18-1" aria-hidden="true" tabindex="-1"></a><span class="fu">coef_test</span>(plm_random, <span class="at">vcov =</span> <span class="st">&quot;CR2&quot;</span>, <span class="at">test =</span> <span class="st">&quot;Satterthwaite&quot;</span>)[<span class="dv">1</span><span class="sc">:</span><span class="dv">2</span>,]</span></code></pre></div>
<pre><code>##     Coef. Estimate   SE t-stat d.f. (Satt) p-val (Satt) Sig.
##     legal     7.31 2.46  2.966       25.18      0.00652   **
##  beertaxa     3.37 5.22  0.647        5.78      0.54258</code></pre>
<p>With random effects estimation, the effect of legal drinking age is
smaller by about 1 death per 100,000. As a procedural aside, note that
<code>coef_test</code> infers that <code>state</code> is the clustering
variable because the call to plm includes only one type of effects
(random state effects).</p>
</div>
<div id="robust-hausman-test" class="section level2">
<h2>Robust Hausman test</h2>
<p>CRVE is also used in specification tests, as in the artificial
Hausman-type test for endogeneity of unobserved effects (Arellano,
1993). As noted above, random effects estimation is more efficient than
fixed effects estimation, but requires the assumption that the
unobserved effects are uncorrelated with the regressors. However, if the
unobserved effects covary with <span class="math inline">\(\mathbf{b}_i,
\mathbf{d}_i\)</span>, then the random-effects estimator will be
biased.</p>
<p>We can test for whether endogeneity is a problem by including
group-centered covariates as additional regressors. Let <span class="math inline">\(\tilde{d}_{it} = d_{it} - \frac{1}{T}\sum_t
d_{it}\)</span>, with <span class="math inline">\(\tilde{b}_{it}\)</span> defined analogously. Now
estimate the regression</p>
<p><span class="math display">\[y_{it} = \beta_t + \gamma_1 b_{it} +
\gamma_2 \tilde{b}_{it} + \delta_1 d_{it} + \delta_2 \tilde{d}_{it} +
\epsilon_{it},\]</span></p>
<p>which does not include state fixed effects. The parameters <span class="math inline">\(\gamma_2,\delta_2\)</span> represent the
differences between the within-groups and between-groups estimands of
<span class="math inline">\(\gamma_1, \delta_1\)</span>. If these are
both zero, then the random effects estimator is unbiased. Thus, the
joint test for <span class="math inline">\(H_0: \gamma_2 = \delta_2 =
0\)</span> amounts to a test for exogeneity of the unobserved
effects.</p>
<p>For efficiency, we estimate this specification using weighted least
squares (although OLS would be valid too):</p>
<div class="sourceCode" id="cb20"><pre class="sourceCode r"><code class="sourceCode r"><span id="cb20-1"><a href="#cb20-1" aria-hidden="true" tabindex="-1"></a>MV_deaths <span class="ot">&lt;-</span> <span class="fu">within</span>(MV_deaths, {</span>
<span id="cb20-2"><a href="#cb20-2" aria-hidden="true" tabindex="-1"></a>  legal_cent <span class="ot">&lt;-</span> legal <span class="sc">-</span> <span class="fu">tapply</span>(legal, state, mean)[<span class="fu">factor</span>(state)]</span>
<span id="cb20-3"><a href="#cb20-3" aria-hidden="true" tabindex="-1"></a>  beer_cent <span class="ot">&lt;-</span> beertaxa <span class="sc">-</span> <span class="fu">tapply</span>(beertaxa, state, mean)[<span class="fu">factor</span>(state)]</span>
<span id="cb20-4"><a href="#cb20-4" aria-hidden="true" tabindex="-1"></a>})</span>
<span id="cb20-5"><a href="#cb20-5" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb20-6"><a href="#cb20-6" aria-hidden="true" tabindex="-1"></a>plm_Hausman <span class="ot">&lt;-</span> <span class="fu">plm</span>(mrate <span class="sc">~</span> <span class="dv">0</span> <span class="sc">+</span> legal <span class="sc">+</span> beertaxa <span class="sc">+</span> legal_cent <span class="sc">+</span> beer_cent <span class="sc">+</span> <span class="fu">factor</span>(year), </span>
<span id="cb20-7"><a href="#cb20-7" aria-hidden="true" tabindex="-1"></a>                   <span class="at">data =</span> MV_deaths,</span>
<span id="cb20-8"><a href="#cb20-8" aria-hidden="true" tabindex="-1"></a>                   <span class="at">effect =</span> <span class="st">&quot;individual&quot;</span>, <span class="at">index =</span> <span class="fu">c</span>(<span class="st">&quot;state&quot;</span>,<span class="st">&quot;year&quot;</span>),</span>
<span id="cb20-9"><a href="#cb20-9" aria-hidden="true" tabindex="-1"></a>                   <span class="at">model =</span> <span class="st">&quot;random&quot;</span>)</span>
<span id="cb20-10"><a href="#cb20-10" aria-hidden="true" tabindex="-1"></a><span class="fu">coef_test</span>(plm_Hausman, <span class="at">vcov =</span> <span class="st">&quot;CR2&quot;</span>, <span class="at">test =</span> <span class="st">&quot;Satterthwaite&quot;</span>)[<span class="dv">1</span><span class="sc">:</span><span class="dv">4</span>,]</span></code></pre></div>
<pre><code>##       Coef. Estimate   SE  t-stat d.f. (Satt) p-val (Satt) Sig.
##       legal   -9.180 7.62 -1.2042       24.94       0.2398     
##    beertaxa    3.395 9.40  0.3613        6.44       0.7295     
##  legal_cent   16.768 8.53  1.9665       25.44       0.0602    .
##   beer_cent    0.424 9.25  0.0458        6.42       0.9648</code></pre>
<p>To conduct a joint test on the centered covariates, we can use the
<code>Wald_test</code> function. The usual way to test this hypothesis
would be to use the <code>CR1</code> variance estimator to calculate the
robust Wald statistic, then use a <span class="math inline">\(\chi^2_2\)</span> reference distribution (or
equivalently, compare a re-scaled Wald statistic to an <span class="math inline">\(F(2,\infty)\)</span> distribution). The
<code>Wald_test</code> function reports the latter version:</p>
<div class="sourceCode" id="cb22"><pre class="sourceCode r"><code class="sourceCode r"><span id="cb22-1"><a href="#cb22-1" aria-hidden="true" tabindex="-1"></a><span class="fu">Wald_test</span>(plm_Hausman, </span>
<span id="cb22-2"><a href="#cb22-2" aria-hidden="true" tabindex="-1"></a>          <span class="at">constraints =</span> <span class="fu">constrain_zero</span>(<span class="fu">c</span>(<span class="st">&quot;legal_cent&quot;</span>,<span class="st">&quot;beer_cent&quot;</span>)), </span>
<span id="cb22-3"><a href="#cb22-3" aria-hidden="true" tabindex="-1"></a>          <span class="at">vcov =</span> <span class="st">&quot;CR1&quot;</span>, <span class="at">test =</span> <span class="st">&quot;chi-sq&quot;</span>)</span></code></pre></div>
<pre><code>##    test Fstat df_num df_denom  p_val sig
##  chi-sq  2.93      2      Inf 0.0534   .</code></pre>
<p>The test is just shy of significance at the 5% level. If we instead
use the <code>CR2</code> variance estimator and our newly proposed
approximate F-test (which is the default in <code>Wald_test</code>),
then we get:</p>
<div class="sourceCode" id="cb24"><pre class="sourceCode r"><code class="sourceCode r"><span id="cb24-1"><a href="#cb24-1" aria-hidden="true" tabindex="-1"></a><span class="fu">Wald_test</span>(plm_Hausman, </span>
<span id="cb24-2"><a href="#cb24-2" aria-hidden="true" tabindex="-1"></a>          <span class="at">constraints =</span> <span class="fu">constrain_zero</span>(<span class="fu">c</span>(<span class="st">&quot;legal_cent&quot;</span>,<span class="st">&quot;beer_cent&quot;</span>)), </span>
<span id="cb24-3"><a href="#cb24-3" aria-hidden="true" tabindex="-1"></a>          <span class="at">vcov =</span> <span class="st">&quot;CR2&quot;</span>)</span></code></pre></div>
<pre><code>##  test Fstat df_num df_denom p_val sig
##   HTZ  2.56      2     11.7  0.12</code></pre>
<p>The low degrees of freedom of the test indicate that we’re definitely
in small-sample territory and should not trust the asymptotic <span class="math inline">\(\chi^2\)</span> approximation.</p>
</div>
<div id="references" class="section level2">
<h2>References</h2>
<p>Angrist, J. D., &amp; Pischke, J. (2009). <em>Mostly harmless
econometrics: An empiricist’s companion</em>. Princeton, NJ: Princeton
University Press.</p>
<p>Angrist, J. D., and Pischke, J. S. (2014). <em>Mastering’metrics: the
path from cause to effect</em>. Princeton, NJ: Princeton University
Press.</p>
<p>Arellano, M. (1993). On the testing of correlated effects with panel
data. Journal of Econometrics, 59(1-2), 87-97. doi: <a href="https://www.sciencedirect.com/science/article/pii/030440769390040C">10.1016/0304-4076(93)90040-C</a></p>
<p>Bell, R. M., &amp; McCaffrey, D. F. (2002). Bias reduction in
standard errors for linear regression with multi-stage samples.
<em>Survey Methodology, 28</em>(2), 169-181.</p>
<p>Cameron, A. C., &amp; Miller, D. L. (2015). A practitioner’s guide to
cluster-robust inference. URL: <a href="http://cameron.econ.ucdavis.edu/research/Cameron_Miller_JHR_2015_February.pdf" class="uri">http://cameron.econ.ucdavis.edu/research/Cameron_Miller_JHR_2015_February.pdf</a></p>
<p>Carpenter, C., &amp; Dobkin, C. (2011). The minimum legal drinking
age and public health. <em>Journal of Economic Perspectives, 25</em>(2),
133-156. doi: <a href="https://doi.org/10.1257/jep.25.2.133">10.1257/jep.25.2.133</a></p>
<p>Imbens, G. W., &amp; Kolesar, M. (2015). Robust standard errors in
small samples: Some practical advice. URL: <a href="https://doi.org/10.1162/REST_a_00552" class="uri">https://doi.org/10.1162/REST_a_00552</a></p>
<p>Pustejovsky, J. E. &amp; Tipton, E. (2016). Small sample methods for
cluster-robust variance estimation and hypothesis testing in fixed
effects models. arXiv: <a href="https://arxiv.org/abs/1601.01981">1601.01981</a> [stat.ME]</p>
<p>Young, A. (2016). Improved, nearly exact, statistical inference with
robust and clustered covariance matrices using effective degrees of
freedom corrections.</p>
</div>



<!-- code folding -->


<!-- dynamically load mathjax for compatibility with self-contained -->
<script>
  (function () {
    var script = document.createElement("script");
    script.type = "text/javascript";
    script.src  = "https://mathjax.rstudio.com/latest/MathJax.js?config=TeX-AMS-MML_HTMLorMML";
    document.getElementsByTagName("head")[0].appendChild(script);
  })();
</script>

</body>
</html>
